-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp - all rights reserved.
-- 
-- For more scripts and sample code, check out 
-- 	http://www.SQLSkills.com
-- For "More than Just Training," see the Industry Experts at 
-- 	http://www.SolidQualityLearning.com
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

CREATE TABLE dbo.Test
(
	col1	int	NOT NULL	identity,
	col2	varchar(10)	NOT NULL
)
go
CREATE VIEW dbo.TestView
AS
SELECT * FROM dbo.Test
go
CREATE PROC dbo.TestProc
AS
SELECT * FROM dbo.Test
go
SELECT * FROM dbo.TestView
EXEC dbo.TestProc
-- same number of cols AND number of rows!
go
ALTER TABLE dbo.Test
ADD col3 int NOT NULL default 2
go
SELECT * FROM TestView
EXEC TestProc
-- same number of rows BUT ONLY the proc sees col3 because the proc 
-- is "reresolved" and "recompiled" after a schema change.
go
ALTER VIEW dbo.TestView
AS
SELECT * FROM dbo.Test
go
SELECT * FROM dbo.TestView
EXEC dbo.TestProc
-- now the view has 3 as well...meaning the app will not get consistent behavior
go

--Don't use * in views/proc